<?php
// $Id: article_attach.inc.php
// Copyright (C)
//   2010      KSUART Project / Kyushu Sangyo University
//   2002-2005 PukiWiki Developers Team v 1.25 2005/09/24 01:12:29 henoheno Exp $
//   2002      Originally written by OKAWARA,Satoshi <kawara@dml.co.jp>
//             http://www.dml.co.jp/~kawara/pukiwiki/pukiwiki.php
//
// article: BBS-like plugin
//

// Message text is defined in language file

define('PLUGIN_ARTICLE_COLS',52); // テキストエリアのカラム数
define('PLUGIN_ARTICLE_ROWS',3); // テキストエリアの行数
define('PLUGIN_ARTICLE_NAME_COLS',25); // 名前テキストエリアのカラム数
define('PLUGIN_ARTICLE_SUBJECT_COLS',25); // 題名テキストエリアのカラム数
define('PLUGIN_ARTICLE_FILE_COLS',25); // 添付ファイルエリアのカラム数
define('PLUGIN_ARTICLE_NAME_FORMAT','$name'); // 名前の挿入フォーマット
define('PLUGIN_ARTICLE_SUBJECT_FORMAT','**$subject'); // 題名の挿入フォーマット

define('PLUGIN_ARTICLE_INS',0); // 挿入する位置 1:欄の前 0:欄の後
define('PLUGIN_ARTICLE_COMMENT',0); // 書き込みの下に一行コメントを入れる 1:入れる 0:入れない
define('PLUGIN_ARTICLE_AUTO_BR',0); // 改行を自動的変換 1:する 0:しない

define('ARTICLE_IMAGE_WIDTH',160); // 投稿画像表示サイズ
define('ARTICLE_SPACER_FILE','file/spacer.gif');  // スペーサ画像の場所 < KSUART only
define('ARTICLE_EDITAUTH_IGNORE',true);  // 添付ファイル付き投稿に、ページ編集権限を確認しない

define("_THREAD_NAME",1);  // 名前を必須にする(0=No, 1=Yes)
define("_THREAD_SUBJECT",1);  // 題名を必須にする(0=No, 1=Yes)
define("_THREAD_BODY",1); // 本文を必須にする(0=No, 1=Yes)

/////////////////////////////////////////////////


include_once PLUGIN_DIR."attach.inc.php";

function plugin_article_attach_action()
{
	global $script, $post, $vars, $cols, $rows, $now;
	global $_title_collided, $_msg_collided, $_title_updated;
	global $_plugin_article_mailto, $_no_subject, $_no_name;
	global $_msg_article_mail_sender, $_msg_article_mail_page;

	if (PKWK_READONLY) die_message('PKWK_READONLY prohibits editing');

	if ($post['msg'] == '')
		return array('msg'=>'','body'=>'');

	$name = ($post['name'] == '') ? $_no_name : $post['name'];
	$name = ($name == '') ? '' : str_replace('$name', $name, PLUGIN_ARTICLE_NAME_FORMAT);
	$subject = ($post['subject'] == '') ? $_no_subject : $post['subject'];
	$subject = ($subject == '') ? '' : str_replace('$subject', $subject, PLUGIN_ARTICLE_SUBJECT_FORMAT);
	$article  = $subject . "\n" . $name . ' ｜ ' . $now . "\n\n";
	
	// 添付ファイルがあれば、添付操作をして#ref()出力する。
	if ($_FILES['attach_file']['name']) {
		$file['tmp_name'] = $_FILES['attach_file']['tmp_name'];
		$file['size']     = $_FILES['attach_file']['size'];
		$file['name']     = date("ymdHis").strtolower(strrchr($_FILES['attach_file']['name'],'.'));
		list( $width, $height, $type) = getimagesize($file['tmp_name']);
		if ( $type ) {
			$height = (int)($height*ARTICLE_IMAGE_WIDTH/$width);
			$width  = ARTICLE_IMAGE_WIDTH;
			$sz = ",{$width}x{$height}";
		}
		
		// 編集権限確認
		if ( !ARTICLE_EDITAUTH_IGNORE) {
			check_editable($post['refer']);
		}
		
		attach_upload($file, $post['refer'],true);
		$article .= "#lightbox({$file['name']},right,around,".$sz.")\n";
		$article .= "#ref(".ARTICLE_SPACER_FILE.",nolink,right,around,24x".$height.")\n";

	   } else {

		$article .= "";
	}
	
	$msg = rtrim($post['msg']);
	if (PLUGIN_ARTICLE_AUTO_BR) {
		//改行の取り扱いはけっこう厄介。特にURLが絡んだときは…
		//コメント行、整形済み行には~をつけないように arino
		$msg = join("\n", preg_replace('/^(?!\/\/)(?!\s)(.*)$/', '$1~', explode("\n", $msg)));
	}
	//$article .= $msg . "\n\n" . '//';
	$article .= $msg . ( $_FILES['attach_file']?"\n#clear":'');
	$article .= "\n" . '~' . "\n" . '~' . "\n";

	if (PLUGIN_ARTICLE_COMMENT) $article .= "\n\n" . '#comment' . "\n";

	$postdata = '';
	$postdata_old  = get_source($post['refer']);
	$article_no = 0;

	foreach($postdata_old as $line) {
		if (! PLUGIN_ARTICLE_INS) $postdata .= $line;
		if (preg_match('/^#article/i', $line)) {
			if ($article_no == $post['article_no'] && $post['msg'] != '')
				$postdata .= $article . "\n";
			++$article_no;
		}
		if (PLUGIN_ARTICLE_INS) $postdata .= $line;
	}

	$postdata_input = $article . "\n";
	$body = '';

	if (md5(@join('', get_source($post['refer']))) != $post['digest']) {
		$title = $_title_collided;

		$body = $_msg_collided . "\n";

		$s_refer    = htmlspecialchars($post['refer']);
		$s_digest   = htmlspecialchars($post['digest']);
		$s_postdata = htmlspecialchars($postdata_input);
		$body .= <<<EOD
<form action="$script?cmd=preview" method="post">
 <div>
  <input type="hidden" name="refer" value="$s_refer" />
  <input type="hidden" name="digest" value="$s_digest" />
  <textarea name="msg" rows="$rows" cols="$cols" id="textarea">$s_postdata</textarea><br />
 </div>
</form>
EOD;

	} else {
		page_write($post['refer'], trim($postdata));
		$title = $_title_updated;
	}
	$retvars['msg'] = $title;
	$retvars['body'] = $body;

	$post['page'] = $post['refer'];
	$vars['page'] = $post['refer'];

	return $retvars;
}

function plugin_article_attach_convert()
{
	global $script, $vars, $digest;
	global $_btn_article, $_btn_name, $_btn_subject, $_btn_attach;
	static $numbers = array();

	if (PKWK_READONLY) return ''; // Show nothing

	if (! isset($numbers[$vars['page']])) $numbers[$vars['page']] = 0;

	$article_no = $numbers[$vars['page']]++;

	$s_page   = htmlspecialchars($vars['page']);
	$s_digest = htmlspecialchars($digest);
	$name_cols = PLUGIN_ARTICLE_NAME_COLS;
	$subject_cols = PLUGIN_ARTICLE_SUBJECT_COLS;
	$file_cols = PLUGIN_ARTICLE_FILE_COLS;
	$article_rows = PLUGIN_ARTICLE_ROWS;
	$article_cols = PLUGIN_ARTICLE_COLS;
	$string = <<<EOD
<form enctype="multipart/form-data" action="$script" method="post">
 <div class="article">
  <input type="hidden" name="article_no" value="$article_no" />
  <input type="hidden" name="plugin" value="article" />
  <input type="hidden" name="digest" value="$s_digest" />
  <input type="hidden" name="refer" value="$s_page" />
  <label for="_p_article_name_$article_no">$_btn_name</label>
  <input type="text" name="name" id="_p_article_name_$article_no" size="$name_cols" /><br />
  <label for="_p_article_subject_$article_no">$_btn_subject</label>
  <input type="text" name="subject" id="_p_article_subject_$article_no" size="$subject_cols" /><br />
  <textarea name="msg" rows="$article_rows" cols="$article_cols">\n</textarea><br />
  $_btn_attach <input type="file" name="attach_file" size="$file_cols"/>　　
  <input type="submit" name="article" value="$_btn_article" /><br /><br /><br /><br />
 </div>
</form>
EOD;

	return $string;
}
?>
