<?php

function plugin_audio_rec_convert() {

	$args = func_get_args();
	if( $args[0] != "") $width = $args[0]; else $width = "576";
	if( $args[1] != "") $height = $args[1]; else $height = "432";

	return <<<HTML
	<button onclick="StartAudioRecording()">StartRecord</button>
	<button onclick="StopAudioRecording()">StopRecord</button>
	<button onclick="PlayAudio()">Playback</button>
	<button onclick="SaveAudio()">SaveAudio</button>
	<span id="message" style="color:red;"></span>

	<script src="p5/p5.min.js"></script>
	<script src="p5/addons/p5.dom.min.js"></script>
	<script src="p5/addons/p5.sound.min.js"></script>
	<script>

		//外部変数
		var mic, recorder, soundFile;
		var state = 0;  // 0:未録音  1:録音中  2:録音済み・再生中
		var fft;


		// 初期設定
		function setup() {
			var cv=createCanvas($width, $height);
			cv.parent("waveForm");
			noFill();

			mic = new p5.AudioIn();
			mic.start();

			recorder = new p5.SoundRecorder();
			recorder.setInput(mic);
			soundFile = new p5.SoundFile();

			fft = new p5.FFT();
			fft.setInput(mic);
		}

		 // アニメーションループ
		function draw() {

			var waveform = fft.waveform();
			//var waveform = fft.analyze();

			background(210);
			beginShape();
			/*
			for (i = 0; i<spectrum.length; i++) {
				vertex(i, map(spectrum[i], 0, 255, height, 0) );
			}
			*/
			for(i=0; i<waveform.length; i++){
				var x = map(i, 0, waveform.length, 0, $width);
				var y = map(waveform[i], -1.0, 1.0, $height, 0);
				vertex(x,y);
			}
			endShape();
		}

		function StartAudioRecording(){
		  if (state!=1 && mic.enabled) {
		    recorder.record(soundFile);
		    //message.textContent="Now Recording!";
		    state = 1;
		  }
		}

		function StopAudioRecording(){
		  if (state===1) {
		    recorder.stop();
		    //message.textContent="Recorded";
		    state = 2;
		  } else if (state===2) {
		    soundFile.stop();
		  }
		}

		function PlayAudio(){
		  if (state===2) {
		    soundFile.play();
		  }
		}

		function SaveAudio(){
		  if (state===2) {
		    saveSound(soundFile, 'myAudio.wav');
		  }
		}

	</script>

	<div id="waveForm"></div>

HTML;
}

function plugin_audio_rec_inline() {
	$args = func_get_args();
	return call_user_func_array('plugin_audio_rec_convert', $args);
}

?>
