<?php
/*
	KCAPTCHA認証つきコメントプラグイン
*/

// Message text is defined in language file

require_once(PLUGIN_DIR . 'comment.inc.php');

// 入力が間違っている時のエラー文
define('WRONG_WARNING', '入力文字列が間違っています');

// 文字列入力欄の説明
define('CAPTCHA_DESC', '認証: ');

// 入力欄の長さ (size)
define('CPT_INPUT_SIZE', 6);

// 入力欄の最大入力文字数 (maxlength)
define('CPT_INPUT_MAX', 6);

function plugin_comment_kcaptcha_action()
{
	global $vars;
	
	if(isset($_SESSION['captcha_keystring']) && $_SESSION['captcha_keystring'] ==  $_POST['keystring']){
	} else {
		return array('msg'=>WRONG_WARNING);
	}
	unset($_SESSION['captcha_keystring']);

	// comment.inc.phpにバトンタッチ
	return plugin_comment_action();
}


function plugin_comment_kcaptcha_convert()
{
	global $vars, $digest, $_btn_comment, $_btn_name, $_msg_comment;
	static $numbers = array();
	static $comment_cols = PLUGIN_COMMENT_SIZE_MSG;

	if (PKWK_READONLY) return ''; // Show nothing

	if (! isset($numbers[$vars['page']])) $numbers[$vars['page']] = 0;
	$comment_no = $numbers[$vars['page']]++;

	$options = func_num_args() ? func_get_args() : array();
	if (in_array('noname', $options)) {
		$nametags = '<label for="_p_comment_comment_' . $comment_no . '">' .
			$_msg_comment . '</label>';
	} else {
		$nametags = '<label for="_p_comment_name_' . $comment_no . '">' .
			$_btn_name . '</label>' .
			'<input type="text" name="name" id="_p_comment_name_' .
			$comment_no .  '" size="' . PLUGIN_COMMENT_SIZE_NAME .
			'" />' . "\n";
	}
	$nodate = in_array('nodate', $options) ? '1' : '0';
	$above  = in_array('above',  $options) ? '1' :
		(in_array('below', $options) ? '0' : PLUGIN_COMMENT_DIRECTION_DEFAULT);

	// kcaptcha
	$kcaptcha_img = "kcaptcha/index.php?".session_name()."=".session_id();
	$desc_str = CAPTCHA_DESC;
	$cpt_input_size = CPT_INPUT_SIZE;
	$cpt_input_max = CPT_INPUT_MAX;

	$script = get_script_uri();
	$s_page = htmlspecialchars($vars['page']);
	$string = <<<EOD
<br />
<form action="$script" method="post">
 <div>
  <input type="hidden" name="plugin" value="comment_kcaptcha" />
  <input type="hidden" name="refer"  value="$s_page" />
  <input type="hidden" name="comment_no" value="$comment_no" />
  <input type="hidden" name="nodate" value="$nodate" />
  <input type="hidden" name="above"  value="$above" />
  <input type="hidden" name="digest" value="$digest" />
  <div>
  $nametags
  <input type="text"   name="msg" id="_p_comment_comment_{$comment_no}" size="$comment_cols" />
  </div>
  <div>
  <img src="$kcaptcha_img" style="width:90px; height:54px;" />
  　$desc_str <input type="text" name="keystring" size="$cpt_input_size" maxlength="$cpt_input_max" />
  　<input type="submit" name="comment" value="$_btn_comment" /><br /><br /><br />
  </div>
 </div>
</form>
EOD;

	return $string;
}

?>
