<?php

function plugin_mic_convert() {

	$args = func_get_args();
	if( $args[0] != "") $width = $args[0]; else $width = "576";
	if( $args[1] != "") $height = $args[1]; else $height = "432";

	// DEFAULT
	//$mode = "waveform";

	for($i=0; $i<3; $i++){
		if( $args[$i] == "analyze") $mode = "analyze";
	}

	return <<<HTML

	<div id="waveForm"></div>

	<button onclick="SetWaveForm()">WaveForm</button>
	<button onclick="SetAnalyze()">Analyze</button>

	<script src="p5/p5.min.js"></script>
	<script src="p5/addons/p5.dom.min.js"></script>
	<script src="p5/addons/p5.sound.min.js"></script>
	<script>

	//外部変数
	var fft;
	var figureMode;

	// 初期設定
	function setup() {
		var cv=createCanvas($width, $height);
		cv.parent("waveForm");
		noFill();

		mic = new p5.AudioIn();
		mic.start();

		fft = new p5.FFT();
		fft.setInput(mic);

		figureMode = "waveform";

	}

	 // アニメーションループ
	function draw() {

		background(200);

		if( figureMode == "waveform" ){
			var waveform = fft.waveform();
			beginShape();
			for(i=0; i<waveform.length; i++){
				var x = map(i, 0, waveform.length, 0, $width);
				var y = map(waveform[i], -1.0, 1.0, $height, 0);
				vertex(x,y);
			}
			endShape();
		}else{
			var spectrum = fft.analyze();
			beginShape();
			for (i = 0; i<spectrum.length; i++) {
				vertex(i, map(spectrum[i], 0, 255, height, 0) );
			}
			endShape();
		}

	}

	function SetWaveForm(){
		figureMode = "waveform";
	}

	function SetAnalyze(){
		figureMode = "analyze";
	}

	</script>

HTML;
}

function plugin_mic_inline() {
	$args = func_get_args();
	return call_user_func_array('plugin_mic_convert', $args);
}

?>
