<?php

function plugin_video_efct_convert() {

	$args = func_get_args();
	if( $args[0] != "") $width = $args[0]; else $width = "576";
	if( $args[1] != "") $height = $args[1]; else $height = "432";

	$id = randomStrings(); // 複数エレメントを独立制御するための乱数

	// DEFAULT
	$effect = "none";
	$autoplay = "autoplay";
	$muted = "muted";
	$loop = "loop";
	$fh = '1';
	$fv = '1';

	for($i=0; $i<8; $i++){
		if( $args[$i] == "mono") $effect = "monochrome";
		if( $args[$i] == "nega") $effect = "negative";
		if( $args[$i] == "embs") $effect = "emboss";
		if( $args[$i] == "standby") $autoplay = "";
		if( $args[$i] == "sound") $muted = "";
		if( $args[$i] == "once") $loop = "";
		if( $args[$i] == "flip-h") $fh = '-1';
		if( $args[$i] == "flip-v") $fv = '-1';
	}
	$style_video='style="display:none;
						object-fit: fill;"';
	$style_canvas='style="background-image: url(./image/DropHere.png);
			-webkit-transform: scale('.$fh.','.$fv.');
			transform: scale('.$fh.','.$fv.');
			background-size: cover;
 			background-color: #AAAAAA;"';

	return <<<HTML

		<div class="videoEffect">
			<video id="video_$id" src="./movie/ColorBars.webm"
				width="$width" height="$height"
				$autoplay $muted $loop controls $style_video>
			</video>
			<canvas id="canvas_$id" class=$effect
					width=$width height=$height $style_canvas>
			</canvas>
		</div>
	<script>

	//requestAnimationFrame(Draw_$id);
	var myTimer_$id = setInterval(Draw_$id,1000/30);

	var cnvs_$id = document.getElementById("canvas_$id");
	var dc_$id =  cnvs_$id.getContext("2d");

	function Draw_$id(){

		dc_$id.drawImage(video_$id,0,0,$width,$height);

		if(cnvs_$id.className == "monochrome"){

			var pxData = dc_$id.getImageData(0,0,$width,$height);  // GET

			for(var y=0; y<$height; y++){
				for(var x=0; x<$width; x++){
					var i = ( y*$width + x ) * 4;
					var m = 0.299*pxData.data[i]
							+0.587*pxData.data[i+1]
							+0.114*pxData.data[i+2];
					pxData.data[i] = pxData.data[i+1] = pxData.data[i+2] = Math.floor(m);
					pxData.data[i+3] = 255; //α値
				}
			}

			dc_$id.putImageData(pxData,0,0);  // PUT

		}else if(cnvs_$id.className == "negative"){

			var pxData = dc_$id.getImageData(0,0,$width,$height);  // GET

			for(var y=0; y<$height; y++){
				for(var x=0; x<$width; x++){
					var i = ( y*$width + x ) * 4;
					pxData.data[i]   = 255 - pxData.data[i];
					pxData.data[i+1] = 255 - pxData.data[i+1];
					pxData.data[i+2] = 255 - pxData.data[i+2];
					pxData.data[i+3] = 255; //α値
				}
			}

			dc_$id.putImageData(pxData,0,0);  // PUT

		}else if(cnvs_$id.className == "emboss"){

			var pxData1 = dc_$id.getImageData(0,0,$width,$height);  // GET
			var pxData2 = dc_$id.getImageData(0,0,$width,$height);  // GET
			var pxData3 = dc_$id.getImageData(0,0,$width,$height);  // Memory

			for(var y=0; y<$height-1; y++){
				for(var x=0; x<$width-1; x++){
					var i = ( y*$width + x ) * 4;
					var j = ( (y+1)*$width + x+1 ) * 4;
					pxData3.data[i]   = Math.floor( ( pxData1.data[i] + 255 - pxData2.data[j] )/2);
					pxData3.data[i+1] = Math.floor( ( pxData1.data[i+1] + 255 - pxData2.data[j+1] )/2);
					pxData3.data[i+2] = Math.floor( ( pxData1.data[i+2] + 255 - pxData2.data[j+2] )/2);
					pxData3.data[i+3] = 255; //α値
				}
			}

			dc_$id.putImageData(pxData3,0,0);  // PUT

		}else{

			// default : through

		}






	}

</script>

HTML;

}

function plugin_video_efct_inline() {
	$args = func_get_args();
	return call_user_func_array('plugin_video_efct_convert', $args);
}

?>
