<?php

function plugin_video_pre_convert() {
	if (func_num_args() < 1) return FALSE;
	$args = func_get_args();
	$name = trim($args[0]);
	if( substr($args[1],-1,1) == "%") $width = $args[1]; else $width = "100%";

	// DEFAULT
	$autoplay = "";
	$muted = "muted";
	$loop = "loop";
	$fh = '1';
	$fv = '1';

	for($i=2; $i<7; $i++){

		if( $args[$i] == "autoplay") $autoplay = "autoplay";
		if( $args[$i] == "sound") $muted = "";
		if( $args[$i] == "once") $loop = "";
		if( $args[$i] == "flip-h") $fh = '-1';
		if( $args[$i] == "flip-v") $fv = '-1';
	}

	$videoStyle='style="-webkit-transform: scale('.$fh.','.$fv.'); transform: scale('.$fh.','.$fv.');"';

	return <<<HTML
		<video width=$width src="movie/$name" $autoplay $muted $loop controls $videoStyle>
		</video>
HTML;

}

function plugin_video_pre_inline() {
	$args = func_get_args();
	return call_user_func_array('plugin_video_pre_convert', $args);
}

?>
