<?php

function plugin_video_rec_convert() {
	$args = func_get_args();
	if( $args[0] != "") $width = $args[0]; else $width = "100%";
	if( $args[1] != "") $height = $args[1]; else $height = "auto";

	return <<<HTML

	<button onclick="startWCRecording()">StartRecord</button>
	<button onclick="stopWCRecording()">StopRecord</button>
	<button onclick="playWCRecordedObject()">Playback</button>
	<a href="#" id="saveVideoButton"><button>SaveVideo</button></a>

	<video id="videoScreen" width=$width height=$height autoplay="1"
		style="border: 1px solid;"></video>

	<script>

		// Global Variable 要注意
		var videoObject;  //localVideo
		var cameraStreamURL = null;
		var anchor = null;
		var cameraStream = null;
		var recorder =  null;
		var blobURL = null;

		navigator.getUserMedia = navigator.getUserMedia || navigator.webkitGetUserMedia || navigator.mozGetUserMedia;
		navigator.getUserMedia({video: true, audio: true}, ShowMedia, DummyFunc);

		anchor = document.getElementById("saveVideoButton");
		anchor.download = 'myVideo.webm';

		function ShowMedia(stream) {
			window.URL = window.URL || window.webkitURL;
			videoObject =  document.getElementById("videoScreen");
			cameraStream  = stream;
			cameraStreamURL = window.URL.createObjectURL(cameraStream);
			videoObject.src = cameraStreamURL
		}

		function DummyFunc() {
			//
		}

		////////////////////////////////

		function startWCRecording() {

			if (!cameraStream) {
			 alert("No Stream!");
			 return;
			}

			if (!recorder) {
				recorder = new MediaRecorder(cameraStream);
			 }

			recorder.ondataavailable = function(evt) {
				console.log("data available, start playback");
				var videoBlob = new Blob([evt.data], { type: evt.data.type });
				blobURL = window.URL.createObjectURL(videoBlob);

				anchor.href = blobURL;
			}

			recorder.start();
		}

		function stopWCRecording() {
			if (recorder) { recorder.stop(); }
		}

		function playWCRecordedObject() {
			if (blobURL) {
				videoObject.src = blobURL;
				videoObject.onended = function() {
				  videoObject.pause();
				  videoObject.src = cameraStreamURL;
				};
				videoObject.play();
			}
		}

	</script>
HTML;

}

function plugin_video_rec_inline() {
	$args = func_get_args();
	return call_user_func_array('plugin_video_rec_convert', $args);
}

?>
