<?php

function plugin_vimeo_convert() {
	if (func_num_args() < 1) return FALSE;
	$args = func_get_args();
	$name = trim($args[0]);
	if( substr($args[1],-1,1) == "%") $width = $args[1]; else $width = "100%";
	if( is_numeric($args[2]) && $args[2]<=3.0 ) $aspect = $args[2]; else $aspect = 0.5625;

	$id = randomStrings(); // 複数エレメントを独立制御するための乱数
	$idSelector = "#"."$id";

	// DEFAULT
	$autoplay = "autoplay=0";
	$loop = 'loop=1';
	$fh = '1';
	$fv = '1';

	for($i=3; $i<7; $i++){

		if( $args[$i] == "autoplay") $autoplay = "autoplay=1";
		if( $args[$i] == "once") $loop = "loop=0";
		if( $args[$i] == "flip-h") $fh = '-1';
		if( $args[$i] == "flip-v") $fv = '-1';
	}
	$iframeStyle='style="position: absolute; top: 0; left: 0; width: 100%; height: 100%; -webkit-transform: scale('.$fh.','.$fv.'); transform: scale('.$fh.','.$fv.');"';

	//$aspect = intval($height) / intval($width) * 100.0;
	//$str_aspect = strval($aspect)."%";
	$str_aspect = strval( $aspect * 100.0 )."%";

	return <<<HTML
	<style type="text/css">
	<!--
			$idSelector {
				position:relative;
				width:$width;
			}
			$idSelector:before {
				content:"";
				display: block;
				padding-top: $str_aspect;
			}
	-->
	</style>
	<div id="$id">
		<iframe src="https://player.vimeo.com/video/$name?$autoplay&$loop" $iframeStyle allowfullscreen></iframe>
	</div>

HTML;

}

function plugin_vimeo_inline() {
	$args = func_get_args();
	return call_user_func_array('plugin_vimeo_convert', $args);
}

?>
